(** Source: directories as sources for more sources. *)

module Make
(Param : sig
  val filter : string -> bool
end) : Source.T =
  Setsrc.Make
    (struct
      let filter url = 
	try (Unix.stat url).Unix.st_kind = Unix.S_DIR
	with _ -> false

      let may_have_changed_since url t = true

      let get_srcs url recursive f =
	let files = Array.to_list (Sys.readdir url) in
	List.filter
	  (fun filename -> (if filter filename then recursive else f filename) && Param.filter filename)
	  (List.map (fun file -> Filename.concat url file) files)

      let move_src new_url old_src =
	Filename.concat new_url (Filename.basename old_src)
    end)
