(** Source: Mozilla email files. *)

open Source

module Param =
  struct
    let filter path = Sys.file_exists (path ^ ".msf")

    let may_have_changed_since = Url.may_have_changed_since

    let text_of_source path = path

    let wrapper path objs =
      let main_pre = Url.preview_of_url path in
      let main_arg = {mime="text/nsmail"; role=""; location=path} in
      let main_obj = ("", ([], String main_pre, Url.args_of_url path)) in
      let lf_src = Url.fields_of_url "source" [] path in
      List.map
	(fun (ref, (lf, pre, args)) ->
	  (ref, (lf_src @ lf, pre, main_arg::args)))
	(main_obj :: objs)
  end
module Make : T =
  Setobj_lexyacc.Make(Param)(Nsmail_p)(Nsmail_l)

(*
module Param =
  struct
    let text_of_source path = Filename.chop_extension path
  end
module Make : Source.T = Fileparts_lexyacc.Make(Param)(Nsmail_p)(Nsmail_l)(
  struct
    let suffix = ["msf"]
    let file_attributes = []
    let content_of_path_ref path ref = [Token.Ident "nsmail"]
    let preview path ref pre = Source.String pre
    let main_arg path = {mime="text/nsmail"; role=""; location=Filename.chop_extension path}
  end)
*)
