{
open Nsmail_p

exception Eof
} 

let white = [' ' '\t']
let sep_car = [',' ';' ':']
let word_char = ['A'-'Z' 'a'-'z' '0'-'9' '-' '.' '@']
let digit = ['0'-'9']

rule token = parse
| "From - " { Start }
| "Message-ID:" white * { IDColon(Lexing.lexeme lexbuf) }
| "Date:" white * { DateColon(Lexing.lexeme lexbuf) }
| "From:" white * { FromColon(Lexing.lexeme lexbuf) }
| "To:" white * { ToColon(Lexing.lexeme lexbuf) }
| "Cc:" white * { CcColon(Lexing.lexeme lexbuf) }
| "CC:" white * { CcColon(Lexing.lexeme lexbuf) }
| "Subject:" white * { SubjectColon(Lexing.lexeme lexbuf) }
| "Content-Length:" white * { LengthColon(Lexing.lexeme lexbuf) }
| sep_car  { Sep(Lexing.lexeme lexbuf) }
| white + { Whites(Lexing.lexeme lexbuf) }
| '\n'     { EOL }
| digit +  { Integer(string_of_int(int_of_string(Lexing.lexeme lexbuf))) }
| word_char + { Word(Lexing.lexeme lexbuf) }
| _ { Others(Lexing.lexeme lexbuf) }
| eof { raise Eof }
