(** Source: union of 2 sources. *)

module Make (S1 : Source.T) (S2 : Source.T) : Source.T =
struct
include Source.Default
type t = | S1 of S1.t | S2 of S2.t 

let parts s  =
match s with
| S1 s -> S1.parts s 
| S2 s -> S2.parts s 

let preview s ref =
match s with
| S1 s -> S1.preview s ref
| S2 s -> S2.preview s ref

let action_args s ref =
match s with
| S1 s -> S1.action_args s ref
| S2 s -> S2.action_args s ref

let init s  =
match s with
| S1 s -> S1.init s 
| S2 s -> S2.init s 

let update s  =
match s with
| S1 s -> S1.update s 
| S2 s -> S2.update s 

let final s  =
match s with
| S1 s -> S1.final s 
| S2 s -> S2.final s 

let move s  new_url =
match s with
| S1 s -> S1.move s  new_url
| S2 s -> S2.move s  new_url

let make url =
try S1 (S1.make url) with _ ->
S2 (S2.make url)

let url s  =
match s with
| S1 s -> S1.url s 
| S2 s -> S2.url s 

end
